#!/usr/bin/env python
#Author: Mark Feineigle
#Create Date: 2016/10/09
#Last Modify: 2016/10/09
''' '''
import BeautifulSoup as bs
from collections import OrderedDict
import py2neo

def makeSoup(path):
  html = open(path).read()
  return bs.BeautifulSoup(html)

def makeDict(soup):
  d = OrderedDict()
  res = soup.findAll("tr")
  element = 1
  while element < 287:
    # get the country
    keys = [link.text for link in res[element].findAll("td")[0].findAll("a") 
	    if not link.text.startswith("[") and len(link.text) > 0]
    # get its borders
    vals = [link.text for link in res[element].findAll("td")[4].findAll("a")
	    if not link.text.startswith("[")]

    element+=1
    d[keys[0]] = vals
  return d

def dict2Txt(data, path):
  with open(path, "w") as fi:
    for key,values in data.iteritems():
      values = [i for i in values if len(i) > 0] #remove empty elements
      fi.write(key.encode("utf-8").strip()+";")
      fi.write(",".join(values).encode("utf-8")+"\n")

def txt2Dict(path):
  d = OrderedDict()
  with open(path, "r") as fi:
    for line in fi.readlines():
      key = line.strip().split(";")[0]
      values = line.strip().split(";")[1].split(",")
      d[key] = values
  return d

def dict2Graph(data):
  py2neo.authenticate("localhost:7474", "neo4j", "password")
  graph = py2neo.Graph()
  count = 0
  for key,values in data.iteritems():
    count+=1
    cmd = "MERGE (n:t_Country {name:{key}, t:True})"
    graph.run(cmd, key=key)
    for value in values:
      if len(value) > 0:
	cmd = "MERGE (n:t_Country {name:{value}, t:True})"
	graph.run(cmd, value=value)

	cmd = '''MATCH (key:t_Country {name:{key}}),
		       (val:t_Country {name:{value}})
		 CREATE UNIQUE (key)-[:BORDERS]-(val)'''
	graph.run(cmd, key=key, value=value)
  print count

if __name__ == '__main__':
  htmlpath = "List of countries and territories by land borders - Wikipedia, the free encyclopedia.html"
  #txtpath = "countryBorders.txt"
  txtpath = "countryBordersEDITED.txt"

  def readData():
    soup = makeSoup(htmlpath)
    d = makeDict(soup)
    dict2Txt(d, txtpath)
  def writeGraph():
    d = txt2Dict(txtpath)
    dict2Graph(d)

  # comment out the appropriate lines to only read or write
  #readData()
  #manually edit the text here
  writeGraph()

